'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Node = function Node(value) {
  var next = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var previous = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

  _classCallCheck(this, Node);

  this.value = value;
  this.next = next;
  this.previous = previous;
};

var _class = function () {
  function _class() {
    _classCallCheck(this, _class);

    this.last = null;
  }

  _createClass(_class, [{
    key: 'add',


    /**
    * Adds a value to the end of the linked list
    * @param {*}
    */
    value: function add(value) {
      var n = new Node(value);

      if (this.isEmpty()) {
        this.last = n;
        n.next = n;
        n.previous = n;
      } else {
        var first = this.last.next;

        this.last.next = n;
        n.previous = this.last;
        first.previous = n;

        if (first === this.last) {
          n.next = this.last;
        } else {
          n.next = first;
        }

        this.last = n;
      }
    }

    /**
     * Adds a value at first position of list
     * @param {*} value
     */

  }, {
    key: 'addFirst',
    value: function addFirst(value) {
      var n = new Node(value);

      if (this.isEmpty()) {
        this.add(value);
      } else {
        var first = this.last.next;
        n.next = first;
        n.previous = this.last;
        first.previous = n;
        this.last.next = n;
      }
    }

    /**
    * Adds a value into a specified position in the list
    * @param {*} value
    * @param {Number} position
    */

  }, {
    key: 'addAtPosition',
    value: function addAtPosition(value, position) {
      var index = 1;
      var current = void 0;
      var n = new Node(value);

      if (position === 0) {
        this.addFirst(value);
        return;
      }

      if (this.isEmpty() && position > 0) {
        throw new Error('Unable to add at position ' + position + ', list is of length ' + (index === 1 ? 0 : index));
      } else {
        current = this.last.next;
      }

      while (index <= position) {
        if (index < position) {
          current = current.next;
          index++;
        } else if (index === position) {
          var tmp = current.next;

          current.next = n;
          tmp.previous = n;
          n.next = tmp;
          n.previous = current;

          break;
        }

        if (current === this.last.next) {
          break;
        }
      }

      if (n.previous === this.last) {
        this.last = n;
      }

      if (index !== position && position !== 0) {
        throw new Error('Unable to add at position ' + position + ', list is of length ' + (index === 1 ? 0 : index));
      }
    }

    /**
     * Search for a value in the list
     * @param  {*} value
     * @return {Node}
     */

  }, {
    key: 'search',
    value: function search(value) {
      var current = this.last;

      do {
        if (current) {
          if (current.value === value) {
            return current;
          }

          current = current.next;
        }
      } while (current !== null && current !== this.last);

      return false;
    }

    /**
     * Delete a value from the list
     * @param  {*} value
     * @return {Boolean}
     */

  }, {
    key: 'delete',
    value: function _delete(value) {
      var node = this.search(value);

      if (node) {
        node.previous.next = node.next;
        node.next.previous = node.previous;

        if (node === this.last) {
          this.last = node.previous;
        }

        return true;
      }

      return false;
    }

    /**
     * Reverse the linked list
     */

  }, {
    key: 'reverse',
    value: function reverse() {
      if (!this.isEmpty()) {
        var first = this.last.next;
        var current = first;
        var tmp = void 0;

        do {
          tmp = current.next;
          current.next = current.previous;
          current.previous = tmp;
          current = tmp;
        } while (current !== first);

        this.last = current;
      }
    }
  }, {
    key: 'isEmpty',
    value: function isEmpty() {
      return this.last === null;
    }
  }, {
    key: 'values',
    get: function get() {
      var values = '';

      if (!this.isEmpty()) {
        var current = this.last.next;

        do {
          values += JSON.stringify(current.value) + ',';
          current = current.next;
        } while (current && current !== this.last.next);

        values = values.slice(0, -1);
      }

      return values;
    }
  }]);

  return _class;
}();

exports.default = _class;