'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Graph = function () {
  function Graph() {
    var isDirected = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

    _classCallCheck(this, Graph);

    this.isDirected = isDirected;
    this.adjList = new Map();
  }

  _createClass(Graph, [{
    key: 'addVertex',
    value: function addVertex(v) {
      this.adjList.set(v, []);
    }
  }, {
    key: 'addEdge',
    value: function addEdge(a, b) {
      this.adjList.get(a).push(b);

      if (!this.isDirected) {
        this.adjList.get(b).push(a);
      }
    }
  }, {
    key: 'print',
    value: function print() {
      var output = '';

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.adjList.keys()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var vertex = _step.value;

          var adjacencies = this.adjList.get(vertex);
          var str = '';

          adjacencies.forEach(function (adjVertex) {
            str += adjVertex + ' ';
          });

          output += vertex + ' => ' + str;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      console.log(output);

      return output;
    }
  }, {
    key: 'bfs',
    value: function bfs(vertexA, vertexB) {
      var _this = this;

      var q = [];
      var visited = new Set();

      q.push([vertexA]);
      visited.add(vertexA);

      var _loop = function _loop() {
        var path = q.shift();
        var v = path[path.length - 1];

        if (v === vertexB) {
          return {
            v: path
          };
        }

        _this.adjList.get(v).forEach(function (adjacent) {
          if (!visited.has(adjacent)) {
            q.push(path.concat([adjacent]));
            visited.add(adjacent);
          }
        });
      };

      while (q.length) {
        var _ret = _loop();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }

      return [];
    }
  }, {
    key: 'dfs',
    value: function dfs(vertexA, vertexB) {
      var visited = new Set();
      var adjList = this.adjList;

      return dfsHelper(vertexA, []);

      /**
       * @param  {*} v
       * @param  {Array} path
       * @return {Array | boolean}
       */
      function dfsHelper(v, path) {
        path.push(v);
        visited.add(v);

        if (v === vertexB) {
          return path;
        }

        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = adjList.get(v)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var adjacent = _step2.value;

            if (!visited.has(adjacent)) {
              var result = dfsHelper(adjacent, path);

              if (result) {
                return path;
              }
            }
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        return false;
      }
    }
  }, {
    key: 'vertices',
    get: function get() {
      return Array.from(this.adjList.keys());
    }
  }]);

  return Graph;
}();

exports.default = Graph;