'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Node = function Node(value) {
  var next = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

  _classCallCheck(this, Node);

  this.value = value;
  this.next = next;
};

var List = function () {
  function List() {
    _classCallCheck(this, List);

    this.first = null;
  }

  _createClass(List, [{
    key: 'add',


    /**
    * Adds a value to the end of the linked list
    * @param {*}
    */
    value: function add(value) {
      var n = typeof value === 'Node' ? value : new Node(value);

      if (this.isEmpty()) {
        this.first = n;
      } else {
        var current = this.first;

        while (current.next != null) {
          current = current.next;
        }

        current.next = n;
      }
    }

    /**
     * Adds a value at first position of list
     * @param {*} value
     */

  }, {
    key: 'addFirst',
    value: function addFirst(value) {
      var n = new Node(value, this.first);
      this.first = n;
    }

    /**
    * Adds a value into a specified position in the list
    * @param {*} value
    * @param {Number} position
    */

  }, {
    key: 'addAtPosition',
    value: function addAtPosition(value, position) {
      var n = new Node(value);
      var index = 1;
      var current = this.first;

      if (position === 0) {
        this.addFirst(value);
        return;
      }

      while (current != null) {
        if (index < position) {
          current = current.next;
          index++;
        } else if (index === position) {
          var tmp = current.next;
          current.next = n;
          n.next = tmp;
          break;
        }
      }

      if (index !== position && position !== 0 || current === null) {
        throw new Error('Unable to add at position ' + position + ', list is of length ' + (index === 1 ? 0 : index));
      }
    }

    /**
     * Search for a value in the list
     * @param  {*} value
     * @return {Node}
     */

  }, {
    key: 'search',
    value: function search(value) {
      var current = this.first;

      while (current !== null) {
        if (current.value === value) {
          return current;
        }

        current = current.next;
      }

      return false;
    }

    /**
     * Delete a value from the list
     * @param  {*} value
     * @return {Boolean}
     */

  }, {
    key: 'delete',
    value: function _delete(value) {
      var current = this.first;

      if (current != null && current.value === value) {
        this.first = current.next;

        return true;
      }

      while (current !== null) {
        if (current.next.value === value) {
          current.next = current.next.next;
          return true;
        }

        current = current.next;
      }

      return false;
    }

    /**
     * Reverse the linked list
     */

  }, {
    key: 'reverse',
    value: function reverse() {
      var next = this.first.next;
      var tmp = void 0;

      while (tmp !== null) {
        tmp = next.next;

        next.next = this.first;
        if (next.next.next === next) {
          next.next.next = null;
        }

        this.first = next;
        next = tmp;
      }
    }

    /**
    * @return {Boolean}
    */

  }, {
    key: 'isEmpty',
    value: function isEmpty() {
      return this.first === null;
    }
  }, {
    key: 'values',
    get: function get() {
      var values = '';

      if (!this.isEmpty()) {
        var current = this.first;

        while (current != null) {
          values += JSON.stringify(current.value) + ',';
          current = current.next;
        }

        values = values.slice(0, -1);
      }

      return values;
    }
  }]);

  return List;
}();

exports.default = List;
;